#ifndef WIN32_SUPPORT_H
#define WIN32_SUPPORT_H

#include "Winsock2.h"
#include "process.h"
#include "windows.h"

#define ioctl_sock(s, cmd, args) ioctlsocket(s, cmd, args)

__inline unsigned long sock_get_inbuffsz (unsigned int sock) {
    unsigned long buffsz = 0;
    if(ioctl_sock(sock, FIONREAD, &buffsz))
        return 0;
    return buffsz;
}

__inline unsigned long sock_set_blockmode (unsigned int sock) {
    unsigned long buffsz = 1;
    if(ioctl_sock(sock, FIONBIO, &buffsz))
        return 0;
    return buffsz;
}

typedef __int64 int64_t;
typedef __int32 int32_t;
typedef HANDLE pthread_t;
typedef HANDLE pthread_mutex_t;
typedef USHORT ushort;

#define pthread_mutex_lock(phmutex)         WaitForSingleObject(*(phmutex),-1)
#define pthread_mutex_unlock(phmutex)       ReleaseMutex(*(phmutex))
#define pthread_mutex_init(phmutex, pattr)  { (*(phmutex)) = CreateMutex(NULL, 0, NULL); }

#define my_event_wait(phmutex)              WaitForSingleObject(*(phmutex),-1)
#define my_event_set(phmutex)               SetEvent(*(phmutex))
#define my_event_init(phmutex, pattr)       { (*(phmutex)) = CreateEvent(NULL, FALSE, TRUE, NULL); }

#define pthread_mutexattr_init(pattr)       { (*(pattr)) = 0; }
#define pthread_mutex_destroy(phmutex)      CloseHandle(*(phmutex))

typedef ULONG pthread_attr_t;
typedef ULONG pthread_mutexattr_t;

#define pthread_attr_init(pattr)                     { (*(pattr)) = 0; }
#define pthread_create(phandle, pattr, entry, ctx)   { (*(phandle)) = (HANDLE)_beginthread(entry, 0, ctx); }
#define pthread_join(hthread, vptr)                  WaitForSingleObject(hthread,-1)
#define pthread_attr_setdetachstate(pattr, flags)    {;}

typedef int socklen_t;

#define gettimeofday(ptime, xxx)           { FILETIME t; GetSystemTimeAsFileTime(&t); (ptime)->tv_usec = (unsigned int)(((int64_t*)&t)[0]/10)%1000; (ptime)->tv_sec = (unsigned int)(((int64_t*)&t)[0]/10)/1000; }

#endif //WIN32_SUPPORT_H